
Ext.define('FP.view.PanelKey', {
    imgSrc: '/fp/resources/images/key_blank.png',
    name: null,
    stage: null,
    location: {
        x: 0,
        y: 0
    },
    highlightFill: null,
    text: null,
    extend: 'FP.utils.Observable',
    constructor: function() {
        this.addEvents(['pressed']);
        this.callParent(arguments);
    },
    loadImage: function(onload) {
        
        var images = FP.view.PanelKey.images,
            currImage;
        if(images === undefined) {
            FP.view.PanelKey.addStatics({
                images: {}
            });
            images = FP.view.PanelKey.images;
        }
        currImage = images[this.imgSrc];
        if(currImage === undefined) {
            currImage = images[this.imgSrc] = new Image();
            
            currImage.src = this.imgSrc;
            currImage.onload = function() {
                onload(currImage);
            };
        } else {
            onload(currImage);
        }
        
    },
    init: function() {
        var stage = this.stage,
            me = this,
            rectOptions = {fill: this.highlightFill, width: 40, height: 38, x: 8, y: 8};
        
        this.state = false;
        this.keyPositionUp = true;
        this.group = new Kinetic.Group(this.location);
        stage.add(this.group);
        this.elements = {};
        
        if(this.highlightFill === null) {
            Ext.apply(rectOptions, {alpha: 0, fill: 'yellow'});
        }
        this.elements.rect = new  Kinetic.Rect(rectOptions)
        
        this.elements.text = new Kinetic.Text({
            x: 30,
            y: 20,
            align: 'center',
            text: this.text,
            fontSize: 13,
            fontFamily: 'Sans',
            textFill: 'black',
            alpha: this.text ? 1: 0 
        });
        
        me.selectGroup = new Kinetic.Group();
        this.loadImage(function(img) {
            var imgEl = new Kinetic.Image({image: img, width: 58, height: 56});
            me.elements.img = imgEl;
            me.group.add(imgEl);
            
            //add large invisible rect to get capture mouse events
            me.selectGroup.add(new Kinetic.Rect({width: imgEl.getWidth(), height: imgEl.getHeight(), fill: 'pink', alpha: 0}));
            
            me.selectGroup.add(me.elements.rect);
            me.selectGroup.add(me.elements.text);
            
//            me.group.add(me.elements.rect);
            me.group.add(me.selectGroup);
//            stage.draw();
//            me.initFlash();
        });
        me.selectGroup.on('mousedown touchstart', function() {
            me.elements.img.setScale(0.8, 0.8);
            me.elements.text.setScale(0.8, 0.8);
            me.elements.img.setCenterOffset(-6, -6);
            setTimeout(function() {
                if(me.keyPositionUp === false) {
                    me.elements.img.setCenterOffset(0, 0);
                    me.elements.text.setScale(1, 1);
                    me.elements.img.setScale(1,1);
                    stage.draw();
                    me.keyPositionUp = true;
                }
            }, 200)
            stage.draw();
            me.keyPositionUp = false;
            me.fireEvent('pressed', me);
        });
        me.selectGroup.on('touchend mouseup mouseout', function() {
            me.elements.img.setScale(1, 1);
            me.elements.text.setScale(1, 1);
            me.elements.img.setCenterOffset(0, 0);
            stage.draw();
            me.keyPositionUp = true;
            
        });
    },
    lightOn: function(flashOn) {
        if(flashOn !== true) {
            this.isFlashing = false;
        }
        this.state = true;
        this.elements.rect.setAlpha(1);
    },
    lightOff: function(flashOn) {
        if(flashOn !== true) {
            this.isFlashing = false;
        }
        this.state = false;
        this.elements.rect.setAlpha(0);
    },
    toggleLed: function() {
        this.state ? this.lightOff(true): this.lightOn(true);
    },
    onTick: function() {
        if(this.isFlashing) {
            this.toggleLed()
        }
    },
    lightFlash: function() {
        this.isFlashing = true;
    }
});

