
console.debug("starting connection.js");

Ext.ns('barco');
Ext.ns('barco.connection');

barco.connection.message = function(config){
    if ( !(this instanceof arguments.callee) ){
        throw new Error("Constructor called as a function");
    }
    this.data = config.data;
    this.successCbk = config.success || null;
    this.failureCbk = config.failure || null;
    this.url = config.url || '/ajax';
    this.scope = config.scope || window;
};

//barco.connection.message.prototype.

barco.connection.msgsToQt = []

barco.connection.sendQt = function(msgObj){
    supercore.sendMsg(msgObj.data);
    barco.connection.msgsToQt.push(msgObj);
};

barco.connection.responseFromQt = function(respCode){
    var msgObj = barco.connection.msgsToQt.shift();
    if(msgObj === undefined){
        console.error("responseFromQt not expected");
    }
    if(respCode < 0) {
        cbk = msgObj.failureCbk;
    }
    else{
        cbk = msgObj.successCbk;
    }
    cbk.call(msgObj.scope, null, respCode);
}

barco.connection.sendAjax = function(msgObj){
    Ext.Ajax.request({
        method: 'POST',
        url: msgObj.url,
        timeout: 40000,
        rawData:   msgObj.data,
        success: function(response, opts) {
            var cbk, 
                respCode = barco.connection.checkAjaxError(response.responseText);
            if(respCode < 0) {
                cbk = msgObj.failureCbk;
            }
            else{
                cbk = msgObj.successCbk;
            }
            
            if(typeof cbk === 'function'){
                cbk.call(msgObj.scope, response, respCode, opts);
            }
        },
        failure: function(response, opts) {
            msgObj.failureCbk.call(msgObj.scope, response, -100000, opts);
        }
    });
};

// returns negative number if response has error/timeout
barco.connection.checkAjaxError = function(response){
    return 0;
}



