/**
 * The model which represents a single unit to control
 */
Ext.define("Muc.model.UnitM", {
    extend: 'Ext.data.Model',
//    idProperty: 'id',
    fields: [
            'id',
            {name: 'name', defaultValue: 'Unnamed'},
            'type', //shared with discovery
            'mac-address', //shared
            'ip-address',  //shared
            'hostname', //shared
            {
                name: 'freeze', 
                persist: false, 
                type: 'string', 
                convert: function(value, record) {
                    if(value === "") {
                        return "n/a"
                    }
                    return value? "on" : "off"
                }
            },
            {
                name: 'input', 
                persist: false,
                convert: function(value, record) {
                    if(value === "") {
                        return "n/a"
                    }
                    return value;
                }
            },
            {name: 'connection', persist: false, defaultValue: 'Disconnected'},
            {name: 'selected', type: 'boolean', defaultValue: false, convert: null},
            'description'
    ]
});
