/**
 * Top level view
 */
Ext.define('Muc.view.Viewport', {
    requires: ['Muc.view.UnitsGrid', 'Muc.view.SelectView'],
    extend: 'Ext.panel.Panel',
    id: 'viewportcontainer',
    width: 1030,
    layout: 'fit',
    initComponent: function() {
        console.log('View port up');
        Ext.apply(this, {
            items: [
                {
                    xtype: 'panel',
                    id: 'theviewport',
                    ui: 'dark',
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    defaults: {
                        margin: '10 10 10 10'
                    },
                    items: [
                        {
                            xtype: 'panel',
                            margin: '10 10 10 10',
                            id: 'header',
                            html: ['<img src="/fp/resources/images/logo-barco.png" height="40px"/>',
                                '<div> Image<span style="font-style: italic;">PRO-II</span> Multi-Unit-Control</div>']
                        },
                        {
                            xtype: 'container',
                            cls: 'hcontainer',
                            bodyPadding: 15,
                            layout: {
                                type: 'column'
                            },
                            items: [
                                Ext.create('Muc.view.UnitsGrid', {columnWidth: 1, height: 300, cls: 'hboxitem'}),
                                {
                                    xtype: 'tabpanel',
                                    cls: 'hboxitem',
                                    columnWith: 0.5,
                                    width: 400,
                                    height: 300,
                                    margin: '0 0 0 10',
                                    items: [
                                        {
                                            title: 'Edit',
                                            id: 'editcard',
                                            ui: 'dark',
                                            layout: 'card',
                                            xtype: 'panel',
                                            items: [
                                                {
                                                    html: '<p>Select Unit to Edit</p>',
                                                    ui: 'dark'
                                                },
                                                Ext.create('Muc.view.UnitEdit', {ui: 'dark'})
                                            ]
                                        },
                                        Ext.create('Muc.view.DiscoveryV', {title: 'Discover', ui: 'dark'})
                                    ]
                                }
                            ]
                        }, 
                        {
                            xtype: 'container',
                            layout: {
                                type: 'hbox',
                                pack: 'center'
                            },
                            items: [
                                Ext.create('Muc.view.SelectView')
                            ]
                        },
                        {
                            xtype: 'container',
                            id: 'inputbus',
                            layout: {
                                type: 'hbox',
                                pack: 'center'
                            },
                            defaults: {
                                width: 55,
                                margin: '0 0 0 10',
                                scale: 'large'
                            },
                            items: [
                                {
                                    xtype: 'button',
                                    text: 'DVI-I',
                                    value: '!1'
                                },
                                {
                                    xtype: 'button',
                                    text: 'HD-15',
                                    value: '!2'
                                },
                                {
                                    xtype: 'button',
                                    text: 'HDMI',
                                    value: '!3'
                                },
                                {
                                    xtype: 'button',
                                    text: 'DP',
                                    value: '!4'
                                },
                                {
                                    xtype: 'button',
                                    text: 'SDI-1',
                                    value: '!5'
                                },
                                {
                                    xtype: 'button',
                                    text: 'SDI-2',
                                    value: '!6'
                                },
                                {
                                    xtype: 'button',
                                    text: 'LOGO',
                                    value: '!7'
                                },
                                {
                                    xtype: 'button',
                                    text: 'BLACK',
                                    value: '!8'
                                },

                                {
                                    margin: '0 0 0 60',
                                    xtype: 'button',
                                    text: 'Freeze',
                                    value: '!I'
                                }
                                
                                
                            ]
                        }
                ]
            }]
        });
        this.callParent(arguments);
    }
});
