Ext.ns('ip2');

ip2.FormatsPanel = function(conf){
    var theForm = this;
    conf = conf || {};
    config = {
        width: 450,
        padding: 10,
        baseCls: 'x-plain',
        defaults: {
            anchor: '95%'
        },
        items:[
            new ip2.FormatsFieldSet()
        ],

        reader: new Ext.data.XmlReader({
            //record: 'HD15Conn' Note: this also works for selection
            record: 'VideoFormat'

        }, [
            'Name', 'HFreq', 'HSync', 'HActive', 'HFP', 'HTotal', 'VFreq',
            'VSync', 'VActive', 'VFP', 'VTotal', 'HSP', 'VSP', 'AR', 'Interlaced',
            'PixelClk', 'VFType', 'VFEnum'
        ]),

        buttons: [{
            text: 'Load',
            listeners: {
                click: function(b, evt){
                    theForm.getForm().load({url:'samplexml/analoginput.xml', waitMsg:'Loading...'});
                }
            }
        }]

    };

    Ext.apply(config, conf);
    ip2.FormatsPanel.superclass.constructor.call(this, config);

    this.addButton('submit', function(){
        theForm.getForm().submit({
            url: 'cgi-bin/test.py',
            method: 'POST',
            failure: function(f,a) {
                console.log("form post failed");
            },
            success: function(f,a) {
                console.log("form post success");
            }

        });
    });

};

ip2.FormatsFieldSet = function (conf) {

    if(ip2.formatsStore == null) {
        ip2.formatsStore = new Ext.data.Store({
            reader: new Ext.data.XmlReader({
                record: 'format',
                idProperty: 'id'
            }, [ //fields
               {name:'id', type:'int'}, {name:'name'}
            ]),
            proxy: new Ext.data.HttpProxy({url:'samplexml/videoformats.xml'})
        });
    }

    config = {
        title: 'Video Formats',
        autoHeight: true,
        defaultType: 'textfield',
        defaults: {width: 180},
        items: [
            {
                xtype: 'combo',
                fieldLabel: 'Format Name',
                name: 'Name', //this is the name used on a FORM fill

                store: ip2.formatsStore,
                valueField: 'name', // these are used by the array store
                displayField: 'name', // for combo box selection

                typeAhead: true,
                editable: true,
                //selectOnFocus: true,
                triggerAction: 'all'
            },
            {
                fieldLabel: 'H. Frequency',
                name: 'HFreq'
            },
            {
                fieldLabel: 'H. Sync',
                name: 'HSync'
            },
            {
                fieldLabel: 'H. Active',
                name: 'HActive'
            },
            {
                fieldLabel: 'H. Total',
                name: 'HTotal'
            },
            {
                fieldLabel: 'H. Front Porch',
                name: 'HFP'
            },
            {
                fieldLabel: 'V. Frequency',
                name: 'VFreq'
            },
            {
                fieldLabel: 'V. Sync',
                name: 'VSync'
            },
            {
                fieldLabel: 'V. Active',
                name: 'VActive'
            },
            {
                fieldLabel: 'V. Front Porch',
                name: 'VFP'
            },
            {
                xtype: 'numberfield',
                fieldLabel: 'V. Total',
                name: 'VTotal'
            }
            //TODO: Finish this
        ]
    };

    Ext.apply(config, conf || {});
    ip2.FormatsFieldSet.superclass.constructor.call(this, config);
};

ip2.formatsFormExtend = function () {
    Ext.extend(ip2.FormatsFieldSet, Ext.form.FieldSet);
    Ext.extend(ip2.FormatsPanel, Ext.form.FormPanel);
};

