Ext.ns('ip2');
ip2.InputFormPanel = function(conf) {

    commonComboConfig = {
        xtype: 'combo',
        width: 120,
        editable: false,
        triggerAction: 'all',
        mode: 'local'
    };

    inputTypeStore = new Ext.data.ArrayStore({
        fields: ['id', 'inputtype'] ,
        data: [['1', 'RGB'], ['2', 'YPbPr'], ['3', 'NTSC/PAL/SECAM'], ['4', 'SDI'],['4', 'DVI']],
        id: 'inputTypeStore'
    });
    
    sampleStore = new Ext.data.ArrayStore({
        fields: ['id', 'sampletype'] ,
        data: [['1', 'Over Sample'], ['2', '1:1']],
        id: 'sampleTypeStore'
    });
    
    config = {
        width: 350,
        padding: 10,
        id: 'Inputform',
        baseCls: 'x-plain',
        //layout: 'auto',
        defaults: {
            anchor: '95%',
            tipText: function(thumb){
                return String(thumb.value) + '%';
            }
        },
        items: [
        Ext.apply ({
            name: 'Input Type',
            id: 'inputtype-combo',
            fieldLabel: 'Input Type',
            store: ['RGB', 'YPbPr', 'NTSC/PAL/SECAM', 'SDI', 'DVI'],
            //displayField: 'inputtype',
            value: 'RGB',
            forceSelection: true,
            listeners: {
                select: function(f,r,i){

                }
            }
        }, commonComboConfig),
        {
            xtype: 'sliderfield',
            name: 'Color Space',
            fieldLabel: 'Color Space',
            value: 50
        },
        Ext.apply({
            name: 'Sampling',
            id: 'sample-combo',
            fieldLabel: 'Sampling',
            store: sampleStore,
            displayField: 'sampletype',
            listeners: {
                select: function(f,r,i){

                }
            }
            }, commonComboConfig)
        
        ]
    };//end config
    
    Ext.apply(config, conf || {});
        ip2.InputFormPanel.superclass.constructor.call(this, config);
};

ip2.inputformExtend = function() {
        Ext.extend(ip2.InputFormPanel, Ext.form.FormPanel);
};
