//place jslint hints here. 
/*global localStorage: true */

/*******************************************************************************
 * The EventManager
 ******************************************************************************/
Ext.ns('barco');
Ext.ns('barco.events');
barco.events.EventManager = Ext.extend(Ext.util.Observable, {
    constructor: function(config) {
        "use strict";
        barco.events.EventManager.superclass.constructor.call(this, config);
        /************
         *arguments: channelIdx (int): 0, 1
         ************/
        this.addSingleEvent('ChannelChange', 0, true);
        
        /************
         *arguments: boolean, true=enable, false=disable
         ************/
        this.addSingleEvent('ChannelBoth', false, true);
        
        this.addSingleEvent('ShowChannelModeButton', false);
    },
    addSingleEvent: function(evt, value, useStorage) {
        "use strict";
        var storageValue,
            storageKey = 'events' + evt;
        if(useStorage) {
            storageValue = localStorage.getItem(storageKey);
            if(storageValue === null) {
                console.log("storage item not found adding: " + storageKey);
                localStorage.setItem(storageKey, JSON.stringify(value));
            } else {
                value = JSON.parse(storageValue);
                console.log("storage item found: " + storageKey  + " value = " + value);
            }
        }
        this.addEvents(evt);
        this[evt] = value;
        this.on(evt, function(value){
           if(useStorage) {
               localStorage.setItem(storageKey, JSON.stringify(value));
           }
           this[evt] = value; 
        });
    }
});
