
barco.ModelessMessage = Ext.extend(Ext.Component, {
    baseCls: 'listitem modelessmessage',
    pressedCls: 'selectedlistitem',
    colorCls: 'msgRed',
    renderTpl: [
        '<div class="{messageCls} {colorCls}">{text}</div>'
    ],
    initRenderData: function () {
        "use strict";
        barco.ModelessMessage.superclass.initRenderData.apply(this, arguments);
        Ext.applyIf(this.renderData, {
            text: this.text,
            messageCls: "modelessmessageText",
            colorCls: this.colorCls
        });
        return this.renderData;
    },
    initComponent: function(){
        "use strict";
        barco.ModelessMessage.superclass.initComponent.call(this, arguments);
        var me = this;
        this.on('afterrender', function() {
            me.textEl = me.el.child(".modelessmessageText");
        });
    },
    popInAndOut: function()
    {
        "use strict";
        if(!this.rendered){
            return;
        }
        this.show();
        Ext.Anim.run(this, 'fade', {
            out: true,
            autoClear: false,
            duration: 3700,
            easing: 'ease-in'
        });
    },
    setText: function(text, colorCls)
    {
        "use strict";
        this.text = text;
        if(this.textEl){
            this.textEl.dom.textContent = text;
            if(colorCls){
                this.textEl.replaceCls(this.colorCls, colorCls);
            }
        }
        if(colorCls){
            this.colorCls = colorCls;
        }
    }
});

Ext.reg('barcomodelessmessage', barco.ModelessMessage);

