
barco.PanZoom = Ext.extend(Ext.form.FormPanel, {
    id: 'panzoom',
    scroll: 'verticle',
    plugins: [{
        ptype: 'wheelplugin'
    }],
    items:[{
        xtype: 'panel',
        id: 'fillPanel',          
        title: 'Fill Options',
        baseCls: 'noclass',
        style: 'padding: 5px',   
        layout: {   
            type: Ext.is.Phone ? 'auto': 'hbox',
            pack: 'center',                
            align: Ext.is.Phone && Ext.Viewport.orientation == 'portrait' ? 'start' : 'center'   //GAN                
        },            
        defaults: {
            xtype: 'button',
            width: '130px',
            margin: '5px',                
            innerTempl:  new Ext.XTemplate('<{outTag}>{fillOpt}</{outTag}>'),               
            handler: function(btn) {
                "use strict";
                var activeInput = barco.utils.xmlselectnode(barco.tags.ActiveConn).textContent,
                node = Ext.DomQuery.select(barco.tags.InView, barco.utils.store.rawxml)[activeInput],
                templ = barco.tags.reverseTemplate(node).template,
                innerObj = {fillOpt:this.fillParam, outTag:'OWINFill'+this.ownerCt.ownerCt.index},
                cmd = templ.apply({value:this.innerTempl.apply(innerObj)}),
                ret = barco.utils.convertXmlToCmd(cmd);                   
                barco.utils.ajaxRequest({
                    request:ret,
                    success:function() {
                        barco.utils.refreshNode(barco.utils.xmlselectnode(barco.tags.OutputMgr));
                    }
                });
            }                                       
        },
        items: [{
            text: 'Match Input',
            id: 'MatchInputButton',
            fillParam: 3
        }, {
            text: 'Fill H',
            id: 'FillHButton',
            fillParam: 0              
        }, {
            text: 'Fill V',
            id: 'FillVButton',
            fillParam: 1                
        }, {
            text: 'Fill H/V',
            id: 'FillHVButton',
            fillParam: 2
        }]            
     }, {
        xtype: 'fieldset',
        title: 'Zoom',
        defaults: {
            xtype: 'barcoadjslider'           
        },
        items: [{
                id: 'pzHsize',
                name: barco.tags.HSize,
                label: 'Zoom H',
                maxValue: 2000,
                minValue: 0,
                cls: 'needwheel'
            }, {
                id: 'pzVsize',
                name: barco.tags.VSize,
                label: 'Zoom V',
                maxValue: 2000,
                minValue: 0,
                cls: 'needwheel',
                showWheelPlugin: true                
            }, {
                xtype: 'togglefield',
                name:'lockaspect',
                label: 'Lock Aspect Ratio',
                hidden: true
        }]
    }, {
        xtype: 'fieldset',
        title: 'Pan',
        defaults: {
            xtype: 'barcoadjslider'
        },
        items: [{
                id: 'pzHpos',
                name: barco.tags.HPos,
                label: 'Pan H',
                maxValue: 2000,
                minValue: 0,
                cls: 'needwheel'
                
            }, {
                id: 'pzVpos',
                name: barco.tags.VPos,
                label: 'Pan V',
                maxValue: 2000,
                minValue: 0,
                cls: 'needwheel'
                
            }
        ]
    }, {
        xtype: 'fieldset',
        title: '',
        defaults: {
            componentStore: "InViewStore"
        },
        items: [{
                id: 'pzUnitField',
                xtype: 'selectfield',
                name: barco.tags.PanZoomUnitValue,
                label: 'Unit',
                options: [{text: 'Percent', value: '0'}, {text: 'Pixels', value: '1'}]
            }]
    
    }],
    index: 0,
    changeOutputChannel: function(chan){
        "use strict";
        if(!this.rendered || (chan != 0 && chan != 1)){
            return;
        }
        this.index = chan;
        barco.utils.refreshNode(barco.modelProxy.stores.InViewStore.data.items[this.index].raw);
        
        // some callback functions for modelChanged is making the fillPanel visible 
        //setTimeout(this.afterSwitch, 50);
    },
    DisableControlForMinDelayQuadToDual: function() {
        "use strict";        
        if(!this.rendered){
            return;
        }
        var isQuadToDual, isMinDelay, i, length; 
        isQuadToDual = barco.utils.isQuadToDualMode();
        isMinDelay = barco.utils.isMinDelayMode();

        this.showWheelPlugin = (!isQuadToDual && !isMinDelay);
        // sub nav options
        length =  Ext.getCmp('panzoom').items.items[1].items.length;
        for (i=0; i < length; i+=1)
        {
            Ext.getCmp('panzoom').items.items[1].items.items[i].setDisabled(isQuadToDual || isMinDelay);
        }
        length = Ext.getCmp('panzoom').fields.length;        
        //zoom pan options
        for (i=0; i < length; i+=1)
        {
            Ext.getCmp('panzoom').fields.items[i].setDisabled(isQuadToDual || isMinDelay);                                                
            if (Ext.getCmp('panzoom').fields.items[i].slidval)
            {
                Ext.getCmp('panzoom').fields.items[i].slidval.disabled = (isQuadToDual || isMinDelay);     
                Ext.getCmp('panzoom').fields.items[i].showWheelPlugin = (!isQuadToDual && !isMinDelay);
            }            
        }               
    },
    loadModel: function() {
        "use strict";                
        return this.loadRecord.apply(this, arguments);
    },
    
    getPanzoomStore: function() {
        "use strict";
        if( barco.modelProxy.stores.InViewStore.data.items.length == 0)
        {
            return "";
        }
        var unit = barco.modelProxy.stores.InViewStore.data.items[this.index].data.PanZoomUnitValue;

        return (unit=="0") ? "PanZoomStorePct" : "PanZoomStorePix";
    },
    
    updatePix: function(store)
    {
        "use strict";
        var hoffset, voffset, cmps, centered, data,
            aoirect = barco.modelProxy.stores.AOIRectStore.data.items[this.index].data,
            pzrect = store.data.items[this.index].data,
            winh = parseInt(aoirect.HSize, 10),
            winv = parseInt(aoirect.VSize, 10),
            x = {
                HSize: parseInt(pzrect.HSize, 10),
                VSize: parseInt(pzrect.VSize, 10),
                HPos:  parseInt(pzrect.HPos, 10)-parseInt(aoirect.HPos, 10),
                Vpos:  parseInt(pzrect.Vpos, 10)-parseInt(aoirect.Vpos, 10)
            };
        centered = barco.utils.topLeftToCenter(x, winh, winv);
        
        data = {};
        data.HPos = centered[0];
        data.Vpos = -centered[1];
        data.HSize = store.data.items[this.index].data.HSize;
        data.VSize = store.data.items[this.index].data.VSize;
        
        hoffset = (data.HSize-winh) / 2;
        voffset = (data.VSize-winv) / 2;
        
        cmps = ["saHsize", "saVsize", "saHpos", "saVpos"];
        Ext.getCmp("pzHsize").adjustMinMax(0);
        Ext.getCmp("pzVsize").adjustMinMax(0);
        Ext.getCmp("pzHpos").adjustMinMax(hoffset);
        Ext.getCmp("pzVpos").adjustMinMax(voffset, true);
        
        this.changesLocked = true;
        this.loadModel({data:data});
        this.changesLocked = false;
    },
    
    updateAll: function(store)
    {
        "use strict";
        //console.log("updating data " + store.barconame);
        this.barcostore = store;
        
        var x, cmp, cmps = ["pzHsize", "pzVsize", "pzHpos", "pzVpos"];
        for(x=0; x<cmps.length; x+=1)
        {
            cmp = Ext.getCmp(cmps[x]);
            cmp.componentStore = store.barconame;
            if(store.barconame=="PanZoomStorePct")
            {
                cmp.adjustMinMax();
            }
        }
        
        if(store.barconame=="PanZoomStorePct")
        {
            this.changesLocked = true;
            this.loadModel(store.data.items[this.index]);
            this.changesLocked = false;
        }
        else
        {
            this.updatePix(store);
        }
    },
        
    afterSwitch: function() {
        "use strict";        
        if (Ext.getCmp('navbar').title >= 'LED')
        {            
            //console.log('Showing Fill Panel');
            Ext.getCmp('fillPanel').show();                            
        }
        else
        {
            //console.log('Hiding Fill Panel');
            Ext.getCmp('fillPanel').hide();
        }        
    },
    
    constructor: function(config) {
        "use strict";
        barco.modelProxy.listeners.addDefaultListeners(this);        
        barco.PanZoom.superclass.constructor.call(this, config);
        //barco.modelProxy.enableGenericFormCallback(this, 'InViewStore');

        barco.modelProxy.addCallback({
            func: this.populatePanel, 
            scope: this, 
            storename:'InViewStore'
        });
        
        this.index = barco.evtManager.ChannelChange;
        
        ///input change
        var onStoreChanged, onUnitChanged,
            x, cmp, cmps, ajaxFunc, i,
            unitField = Ext.getCmp("pzUnitField"),              
            visibleByInputCbk = function(xml){
                if(this.rendered && this.isVisible())
                {
                    for(i=0;i<5;i+=1) {
                        if (this.items.items[i].id != "fillPanel") {
                            this.items.items[i].setVisible(!barco.utils.isInputStatic());
                        }
                    }                    
                }                  
            };          
        
        barco.modelProxy.addCallback({func: visibleByInputCbk, scope: this, storename: 'SystemStore'});
        barco.modelProxy.addCallback({
            func: this.DisableControlForMinDelayQuadToDual, 
            scope: this
        });        
        this.on('show', function() {
            visibleByInputCbk.call(this);        
            this.DisableControlForMinDelayQuadToDual();
        });
        
        onStoreChanged = function(rawxml, store){
            var currstore = this.getPanzoomStore();
            if(!this.rendered || this.getPanzoomStore() != store.barconame)
            {
                return;
            }
            this.updateAll(store);
        };
        barco.modelProxy.addCallback({func: onStoreChanged, scope: this, storename: 'PanZoomStorePct'});
        barco.modelProxy.addCallback({func: onStoreChanged, scope: this, storename: 'PanZoomStorePix'});

        ///changed pix <--> pct
        onUnitChanged = function(sel, val){
            var store, storename = (val=="0") ? "PanZoomStorePct" : "PanZoomStorePix";
            if(!this.rendered)
            {
                return;
            }
            Ext.DomQuery.selectNode("PanZoomUnitValue", barco.modelProxy.stores.InViewStore.data.items[this.index].raw).textContent = val;
            this.changesLocked = true;
            barco.modelProxy.stores.InViewStore.load();
            this.changesLocked = false;
            
            store = barco.modelProxy.stores[storename];
            barco.utils.refreshNode(store.data.items[this.index].raw, storename);
        };
        unitField.on("change", onUnitChanged, this);
        
        this.on('beforeshow', function(cmp) {
            this.index = barco.evtManager.ChannelChange;
            if(barco.modelProxy.stores.InViewStore.data.items.length > 0) {
                barco.utils.refreshNode(barco.modelProxy.stores.InViewStore.data.items[this.index].raw);
            }
        });

        //this.on('beforeactivate', this.afterSwitch);
        this.on('activate', this.afterSwitch);            
        
        barco.evtManager.on("ChannelChange", this.changeOutputChannel, this);        
    }
});
