/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

Ext.ns('ip2');
ip2.MasterPanel = function(conf) {


    spacer = {
        xtype: 'spacer',
        width: 25
    };
    //---------------------Input Button class-----------------------------------
    InputButton = function(conf) {
        config = {
            text: 'text',
            tooltip: 'not set',
            enableToggle: true,
            toggleGroup: 'menu-btns',
            width: 48
        };
        Ext.apply(config, conf || {});

        InputButton.superclass.constructor.call(this, config);
    };

    Ext.extend(InputButton, Ext.Button);
    //---------------------Input Button class-----------------------------------


    config = {
        title: 'Master',
        region: 'center',
        boxMinWidth: 100,
        id: 'masterPanel',
        layout: {
            type: 'card',
            padding: '5'
        },
        tbar: [{
            split: true,
            text: 'Details Panel Location',
            id: 'details-panel-button',
            handler: this.toggleDetails.createDelegate(this, []),
            menu: {
                id: 'details-menu',
                cls: 'details-menu',
                width: 100,
                items: [{
                    text: 'Bottom',
                    checked: false,
                    group: 'rp-group',
                    checkHandler: this.toggleDetails,
                    scope: this,
                    iconCls: 'details-bottom'
                }, {
                    text: 'Right',
                    checked: true,
                    group: 'rp-group',
                    checkHandler: this.toggleDetails,
                    scope: this,
                    iconCls: 'details-right'
                }, {
                    text: 'Hide',
                    checked: false,
                    group: 'rp-group',
                    checkHandler: this.toggleDetails,
                    scope: this,
                    iconCls: 'details-hide'
                }]
            }
        },
        {
            xtype: 'tbfill'
        },

        new InputButton({
            text: "DVI",
            tooltip: "Input 1",
            pressed: true
        }),
        spacer,
        new InputButton({
            text: "HD-15",
            tooltip: "Input 2"
        }),
        spacer,
        new InputButton({
            text: "HDMI",
            tooltip: "Input 3"
        }),
        spacer,
        new InputButton({
            text: "DP",
            tooltip: "Input 4"
        }),
        spacer,
        new InputButton({
            text: "SDI 1",
            tooltip: "Input 5"
        }),
        spacer,
        new InputButton({
            text: "SDI 2",
            tooltip: "Input 6"
        }),
        spacer,
        {
            xtype: 'button',
            text: 'Save Config',
            icon: 'images/savecfg.png'
        }
        ],
        items: [
        {
            xtype: 'panel',
            layout: 'vbox',
            id: 'Input-panel',
            items:  [new ip2.InputFormPanel({})]
        },
        {
            xtype: 'panel',
            layout: 'vbox',
            id: 'Video Format-panel',
            items: [new ip2.FormatsPanel()]
        },
        {
            xtype: 'panel',
            layout: 'vbox',
            id: 'Formats-panel',
            items: [new ip2.FormatsPanel()]
        },
        {
            xtype: 'panel',
            layout: 'vbox',
            id: 'Output-panel'
        },
            new ip2.WebShellPanel({id:'WebShell-panel'})
        ]
    };

    Ext.apply(config, conf || {});

    ip2.MasterPanel.superclass.constructor.call(this, config);

};

ip2.masterPanelExtend = function ()
{
    Ext.extend(ip2.MasterPanel, Ext.Panel, {

        toggleDetails: function(checkItem, pressed) {
            if (!checkItem) {
                var readMenu = Ext.menu.MenuMgr.get('details-menu');
                readMenu.render();
                var items = readMenu.items.items;
                var b = items[0], r = items[1], h = items[2];
                if (b.checked) {
                    r.setChecked(true);
                } else if (r.checked) {
                    h.setChecked(true);
                } else if (h.checked) {
                    b.setChecked(true);
                }
                return;
            }
            if (pressed) {
                var details = Ext.getCmp('details-panel');
                var right = Ext.getCmp('right-details');
                var bot = Ext.getCmp('bottom-details');
                switch (checkItem.text) {
                    case 'Bottom':
                        right.hide();
                        right.remove(details, false);
                        bot.add(details);
                        bot.show();
                        bot.ownerCt.doLayout();
                        break;
                    case 'Right':
                        bot.hide();
                        bot.remove(details, false);
                        right.add(details);
                        right.show();
                        right.ownerCt.doLayout();
                        break;
                    case 'Hide':
                        bot.hide();
                        right.hide();
                        right.remove(details, false);
                        bot.remove(details, false);
                        right.ownerCt.doLayout();
                        break;
                }
            }
        }
    });
};
